package com.gyee.redis2taos.service;

import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.sax.handler.RowHandler;
import com.gyee.redis2taos.config.FilePathConfig;
import com.gyee.redis2taos.config.TaosConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
public class FileService {

    @Autowired
    private TaosConfig taosConfig;

    private List<StringBuilder> sbList = new ArrayList<>();
    private StringBuilder sb = new StringBuilder();
    private String type = null;
    private List<String> point = new ArrayList<>();

    private String s0 = null;
    private int i = 0;
    private String substring = null;

    public List<StringBuilder> getExcelTaos() {
        if (sbList.size() == 0)
            ExcelUtil.readBySax(FilePathConfig.getExcelPath() + "Taos及Redis更新表.xlsx", 0, createRowHandler());
        log.info("Excel数据转换完毕！");
        return sbList;
    }

    public List<String> getExcelRedis() {
        if (point.size() == 0) getExcelTaos();
        return point;
    }

    private RowHandler createRowHandler() {
        return new RowHandler() {
            @Override
            public void handle(int sheetIndex, long rowIndex, List<Object> rowlist) {
                //entity = new TaosEntity();
                if (rowIndex == 0) {
                    log.info("Excel读取完毕！");
                    sbList.add(sb);
                    sb.append("create table");
                    return;
                }
                if (rowIndex % 2999 == 0) {
                    sb = new StringBuilder();
                    sbList.add(sb);
                    sb.append("create table");
                }
                if ("double".equals(rowlist.get(7))) {
                    type = taosConfig.getAIStableName();
                } else {
                    type = taosConfig.getDIStableName();
                }
                s0 = rowlist.get(0).toString();
                i = s0.indexOf(".");
                substring = s0.substring(i + 1);
                sb.append(" if not exists ").append(taosConfig.getDbName()).append(".").append(substring).append(" using ")
                        .append(taosConfig.getDbName()).append(".").append(type).append(" tags('").append(rowlist.get(1)).append("','")
                        .append(rowlist.get(2)).append("','").append(rowlist.get(3)).append("','").append(rowlist.get(4)).append("','")
                        .append(rowlist.get(5)).append("','").append(rowlist.get(6)).append("','").append(s0.substring(0, i < 0 ? 0 : i))
                        .append("')");
                point.add(substring);
                //entities.add(entity);
            }
        };
    }
}
