package com.gyee.redis2taos.service;

import com.gyee.redis2taos.config.RedisConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import redis.clients.jedis.Jedis;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

@Slf4j
@Service
public class RedisService {

    @Resource
    private FileService fileService;
    @Resource
    private RedisConfig redisConfig;

    private static final ThreadLocal<SimpleDateFormat> sdf = ThreadLocal.withInitial(() -> new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"));

    public void creatTables() {
        List<String> excelRedis = fileService.getExcelRedis();
        Map<String, String> map = null;
        Date date = new Date();
        try (Jedis jedis = redisConfig.getJedis();) {
            for (String excelRedi : excelRedis) {
                if (!jedis.exists(excelRedi)) {
                    map = new LinkedHashMap<>();
                    map.put("pointid", excelRedi);
                    map.put("value", "0");
                    map.put("timestamp", String.valueOf(date.getTime()/1000));
                    map.put("datetime", sdf.get().format(date));
                    map.put("status", "0");
                    jedis.hmset(excelRedi, map);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("redis建表完成！");
    }

    public Set<String> getKeys() {
        return redisConfig.getJedis().keys("*");
    }
}
